/* game.c generated by valac 0.42.3, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <math.h>


#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_CLOSED_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];
enum  {
	TILE_MOVE_SIGNAL,
	TILE_CLOSE_SIGNAL,
	TILE_NUM_SIGNALS
};
static guint tile_signals[TILE_NUM_SIGNALS] = {0};

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_COLOR_NUM_PROPERTY,
	GAME_ROWS_PROPERTY,
	GAME_COLUMNS_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_UPDATE_SCORE_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_STARTED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint grid_x;
	gint grid_y;
	gint color;
	gboolean visited;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _TilePrivate {
	gboolean _closed;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Tile** tiles;
	gint tiles_length1;
	gint tiles_length2;
	gboolean is_started;
	gint _score;
	gint _color_num;
	gint _rows;
	gint _columns;
};


static gint Tile_private_offset;
static gpointer tile_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
Tile* tile_new (gint x,
                gint y,
                gint c);
Tile* tile_construct (GType object_type,
                      gint x,
                      gint y,
                      gint c);
void tile_update_position (Tile* self,
                           gint new_x,
                           gint new_y);
gboolean tile_get_closed (Tile* self);
void tile_set_closed (Tile* self,
                      gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void tile_finalize (GObject * obj);
static void _vala_tile_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_tile_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
Game* game_new (gint rows,
                gint columns,
                gint color_num);
Game* game_construct (GType object_type,
                      gint rows,
                      gint columns,
                      gint color_num);
static GList* _game_connected_tiles (Game* self,
                              Tile* li);
gint game_get_rows (Game* self);
gint game_get_columns (Game* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GList* game_connected_tiles (Game* self,
                             Tile* li);
Tile* game_get_tile (Game* self,
                     gint x,
                     gint y);
gboolean game_remove_connected_tiles (Game* self,
                                      Tile* tile);
void game_increment_score_from_tiles (Game* self,
                                      gint n_tiles);
gboolean game_has_completed (Game* self);
gboolean game_has_won (Game* self);
void game_increment_score (Game* self,
                           gint increment);
void game_reset_visit (Game* self);
gint game_get_score (Game* self);
void game_set_score (Game* self,
                     gint value);
gint game_get_color_num (Game* self);
void game_set_color_num (Game* self,
                         gint value);
void game_set_rows (Game* self,
                    gint value);
void game_set_columns (Game* self,
                       gint value);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
tile_get_instance_private (Tile* self)
{
	return G_STRUCT_MEMBER_P (self, Tile_private_offset);
}


Tile*
tile_construct (GType object_type,
                gint x,
                gint y,
                gint c)
{
	Tile * self = NULL;
#line 40 "../src/game.vala"
	self = (Tile*) g_object_new (object_type, NULL);
#line 42 "../src/game.vala"
	self->grid_x = x;
#line 43 "../src/game.vala"
	self->grid_y = y;
#line 44 "../src/game.vala"
	self->color = c;
#line 40 "../src/game.vala"
	return self;
#line 229 "game.c"
}


Tile*
tile_new (gint x,
          gint y,
          gint c)
{
#line 40 "../src/game.vala"
	return tile_construct (TYPE_TILE, x, y, c);
#line 240 "game.c"
}


void
tile_update_position (Tile* self,
                      gint new_x,
                      gint new_y)
{
	gint old_x = 0;
	gint _tmp0_;
	gint old_y = 0;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
#line 48 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/game.vala"
	_tmp0_ = self->grid_x;
#line 50 "../src/game.vala"
	old_x = _tmp0_;
#line 51 "../src/game.vala"
	_tmp1_ = self->grid_y;
#line 51 "../src/game.vala"
	old_y = _tmp1_;
#line 53 "../src/game.vala"
	_tmp3_ = old_x;
#line 53 "../src/game.vala"
	if (new_x != _tmp3_) {
#line 53 "../src/game.vala"
		_tmp2_ = TRUE;
#line 271 "game.c"
	} else {
		gint _tmp4_;
#line 53 "../src/game.vala"
		_tmp4_ = old_y;
#line 53 "../src/game.vala"
		_tmp2_ = new_y != _tmp4_;
#line 278 "game.c"
	}
#line 53 "../src/game.vala"
	if (_tmp2_) {
#line 282 "game.c"
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 55 "../src/game.vala"
		self->grid_x = new_x;
#line 56 "../src/game.vala"
		self->grid_y = new_y;
#line 59 "../src/game.vala"
		_tmp5_ = tile_get_closed (self);
#line 59 "../src/game.vala"
		_tmp6_ = _tmp5_;
#line 59 "../src/game.vala"
		if (!_tmp6_) {
#line 295 "game.c"
			gint _tmp7_;
			gint _tmp8_;
#line 60 "../src/game.vala"
			_tmp7_ = old_x;
#line 60 "../src/game.vala"
			_tmp8_ = old_y;
#line 60 "../src/game.vala"
			g_signal_emit (self, tile_signals[TILE_MOVE_SIGNAL], 0, _tmp7_, _tmp8_, new_x, new_y);
#line 304 "game.c"
		}
	}
}


gboolean
tile_get_closed (Tile* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 20 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/game.vala"
	_tmp0_ = self->priv->_closed;
#line 20 "../src/game.vala"
	result = _tmp0_;
#line 20 "../src/game.vala"
	return result;
#line 323 "game.c"
}


void
tile_set_closed (Tile* self,
                 gboolean value)
{
	gboolean _tmp0_;
#line 21 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/game.vala"
	self->priv->_closed = value;
#line 25 "../src/game.vala"
	_tmp0_ = self->priv->_closed;
#line 25 "../src/game.vala"
	if (_tmp0_) {
#line 340 "game.c"
		gint _tmp1_;
		gint _tmp2_;
#line 26 "../src/game.vala"
		_tmp1_ = self->grid_x;
#line 26 "../src/game.vala"
		_tmp2_ = self->grid_y;
#line 26 "../src/game.vala"
		g_signal_emit (self, tile_signals[TILE_CLOSE_SIGNAL], 0, _tmp1_, _tmp2_);
#line 349 "game.c"
	}
#line 21 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, tile_properties[TILE_CLOSED_PROPERTY]);
#line 353 "game.c"
}


static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/game.vala"
	g_return_if_fail (n_param_values == 5);
#line 14 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/game.vala"
		data1 = closure->data;
#line 14 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 379 "game.c"
	} else {
#line 14 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/game.vala"
		data2 = closure->data;
#line 385 "game.c"
	}
#line 14 "../src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 391 "game.c"
}


static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/game.vala"
		data1 = closure->data;
#line 14 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 417 "game.c"
	} else {
#line 14 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/game.vala"
		data2 = closure->data;
#line 423 "game.c"
	}
#line 14 "../src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 429 "game.c"
}


static void
tile_class_init (TileClass * klass)
{
#line 14 "../src/game.vala"
	tile_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Tile_private_offset);
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tile_get_property;
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tile_set_property;
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
#line 14 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TILE_CLOSED_PROPERTY, tile_properties[TILE_CLOSED_PROPERTY] = g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/game.vala"
	tile_signals[TILE_MOVE_SIGNAL] = g_signal_new ("move", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 14 "../src/game.vala"
	tile_signals[TILE_CLOSE_SIGNAL] = g_signal_new ("close", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 452 "game.c"
}


static void
tile_instance_init (Tile * self)
{
#line 14 "../src/game.vala"
	self->priv = tile_get_instance_private (self);
#line 17 "../src/game.vala"
	self->priv->_closed = FALSE;
#line 33 "../src/game.vala"
	self->visited = FALSE;
#line 465 "game.c"
}


static void
tile_finalize (GObject * obj)
{
	Tile * self;
#line 14 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
#line 477 "game.c"
}


/**
 *  This is the model layer of a tile.
 */
GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		Tile_private_offset = g_type_add_instance_private (tile_type_id, sizeof (TilePrivate));
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}


static void
_vala_tile_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	switch (property_id) {
#line 14 "../src/game.vala"
		case TILE_CLOSED_PROPERTY:
#line 14 "../src/game.vala"
		g_value_set_boolean (value, tile_get_closed (self));
#line 14 "../src/game.vala"
		break;
#line 515 "game.c"
		default:
#line 14 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/game.vala"
		break;
#line 521 "game.c"
	}
}


static void
_vala_tile_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	switch (property_id) {
#line 14 "../src/game.vala"
		case TILE_CLOSED_PROPERTY:
#line 14 "../src/game.vala"
		tile_set_closed (self, g_value_get_boolean (value));
#line 14 "../src/game.vala"
		break;
#line 542 "game.c"
		default:
#line 14 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/game.vala"
		break;
#line 548 "game.c"
	}
}


static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}


Game*
game_construct (GType object_type,
                gint rows,
                gint columns,
                gint color_num)
{
	Game * self = NULL;
	Tile** _tmp0_;
#line 99 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 101 "../src/game.vala"
	self->priv->_rows = rows;
#line 102 "../src/game.vala"
	self->priv->_columns = columns;
#line 103 "../src/game.vala"
	self->priv->_color_num = color_num;
#line 106 "../src/game.vala"
	_tmp0_ = g_new0 (Tile*, (rows * columns) + 1);
#line 106 "../src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 106 "../src/game.vala"
	self->priv->tiles = _tmp0_;
#line 106 "../src/game.vala"
	self->priv->tiles_length1 = rows;
#line 106 "../src/game.vala"
	self->priv->tiles_length2 = columns;
#line 586 "game.c"
	{
		gint x = 0;
#line 108 "../src/game.vala"
		x = 0;
#line 591 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 108 "../src/game.vala"
			_tmp1_ = TRUE;
#line 108 "../src/game.vala"
			while (TRUE) {
#line 598 "game.c"
				gint _tmp3_;
#line 108 "../src/game.vala"
				if (!_tmp1_) {
#line 602 "game.c"
					gint _tmp2_;
#line 108 "../src/game.vala"
					_tmp2_ = x;
#line 108 "../src/game.vala"
					x = _tmp2_ + 1;
#line 608 "game.c"
				}
#line 108 "../src/game.vala"
				_tmp1_ = FALSE;
#line 108 "../src/game.vala"
				_tmp3_ = x;
#line 108 "../src/game.vala"
				if (!(_tmp3_ < columns)) {
#line 108 "../src/game.vala"
					break;
#line 618 "game.c"
				}
				{
					gint y = 0;
#line 110 "../src/game.vala"
					y = 0;
#line 624 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 110 "../src/game.vala"
						_tmp4_ = TRUE;
#line 110 "../src/game.vala"
						while (TRUE) {
#line 631 "game.c"
							gint _tmp6_;
							gint c = 0;
							Tile** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
							gint _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							Tile* _tmp13_;
							Tile* _tmp14_;
#line 110 "../src/game.vala"
							if (!_tmp4_) {
#line 646 "game.c"
								gint _tmp5_;
#line 110 "../src/game.vala"
								_tmp5_ = y;
#line 110 "../src/game.vala"
								y = _tmp5_ + 1;
#line 652 "game.c"
							}
#line 110 "../src/game.vala"
							_tmp4_ = FALSE;
#line 110 "../src/game.vala"
							_tmp6_ = y;
#line 110 "../src/game.vala"
							if (!(_tmp6_ < rows)) {
#line 110 "../src/game.vala"
								break;
#line 662 "game.c"
							}
#line 112 "../src/game.vala"
							c = (gint) floor (g_random_double () * color_num);
#line 113 "../src/game.vala"
							_tmp7_ = self->priv->tiles;
#line 113 "../src/game.vala"
							_tmp7__length1 = self->priv->tiles_length1;
#line 113 "../src/game.vala"
							_tmp7__length2 = self->priv->tiles_length2;
#line 113 "../src/game.vala"
							_tmp8_ = y;
#line 113 "../src/game.vala"
							_tmp9_ = x;
#line 113 "../src/game.vala"
							_tmp10_ = x;
#line 113 "../src/game.vala"
							_tmp11_ = y;
#line 113 "../src/game.vala"
							_tmp12_ = c;
#line 113 "../src/game.vala"
							_tmp13_ = tile_new (_tmp10_, _tmp11_, _tmp12_);
#line 113 "../src/game.vala"
							_g_object_unref0 (_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_]);
#line 113 "../src/game.vala"
							_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_] = _tmp13_;
#line 113 "../src/game.vala"
							_tmp14_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
#line 690 "game.c"
						}
					}
				}
			}
		}
	}
#line 117 "../src/game.vala"
	self->priv->is_started = FALSE;
#line 99 "../src/game.vala"
	return self;
#line 701 "game.c"
}


Game*
game_new (gint rows,
          gint columns,
          gint color_num)
{
#line 99 "../src/game.vala"
	return game_construct (TYPE_GAME, rows, columns, color_num);
#line 712 "game.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 721 "game.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 121 "../src/game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 730 "game.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 121 "../src/game.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 739 "game.c"
}


static GList*
_game_connected_tiles (Game* self,
                       Tile* li)
{
	GList* result = NULL;
	GList* cl = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gint x = 0;
	gint _tmp4_;
	gint y = 0;
	gint _tmp5_;
	Tile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gint _tmp28_;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gint _tmp46_;
	gint _tmp47_;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
	gint _tmp65_;
#line 121 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../src/game.vala"
	cl = NULL;
#line 125 "../src/game.vala"
	_tmp1_ = li->visited;
#line 125 "../src/game.vala"
	if (_tmp1_) {
#line 125 "../src/game.vala"
		_tmp0_ = TRUE;
#line 780 "game.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 125 "../src/game.vala"
		_tmp2_ = tile_get_closed (li);
#line 125 "../src/game.vala"
		_tmp3_ = _tmp2_;
#line 125 "../src/game.vala"
		_tmp0_ = _tmp3_;
#line 790 "game.c"
	}
#line 125 "../src/game.vala"
	if (_tmp0_) {
#line 126 "../src/game.vala"
		result = cl;
#line 126 "../src/game.vala"
		return result;
#line 798 "game.c"
	}
#line 128 "../src/game.vala"
	_tmp4_ = li->grid_x;
#line 128 "../src/game.vala"
	x = _tmp4_;
#line 129 "../src/game.vala"
	_tmp5_ = li->grid_y;
#line 129 "../src/game.vala"
	y = _tmp5_;
#line 131 "../src/game.vala"
	li->visited = TRUE;
#line 133 "../src/game.vala"
	_tmp6_ = _g_object_ref0 (li);
#line 133 "../src/game.vala"
	cl = g_list_append (cl, _tmp6_);
#line 135 "../src/game.vala"
	_tmp9_ = y;
#line 135 "../src/game.vala"
	_tmp10_ = self->priv->_rows;
#line 135 "../src/game.vala"
	if ((_tmp9_ + 1) < _tmp10_) {
#line 820 "game.c"
		Tile** _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		gint _tmp12_;
		gint _tmp13_;
		Tile* _tmp14_;
#line 135 "../src/game.vala"
		_tmp11_ = self->priv->tiles;
#line 135 "../src/game.vala"
		_tmp11__length1 = self->priv->tiles_length1;
#line 135 "../src/game.vala"
		_tmp11__length2 = self->priv->tiles_length2;
#line 135 "../src/game.vala"
		_tmp12_ = y;
#line 135 "../src/game.vala"
		_tmp13_ = x;
#line 135 "../src/game.vala"
		_tmp14_ = _tmp11_[((_tmp12_ + 1) * _tmp11__length2) + _tmp13_];
#line 135 "../src/game.vala"
		_tmp8_ = _tmp14_ != NULL;
#line 841 "game.c"
	} else {
#line 135 "../src/game.vala"
		_tmp8_ = FALSE;
#line 845 "game.c"
	}
#line 135 "../src/game.vala"
	if (_tmp8_) {
#line 849 "game.c"
		gint _tmp15_;
		Tile** _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		gint _tmp17_;
		gint _tmp18_;
		Tile* _tmp19_;
		gint _tmp20_;
#line 135 "../src/game.vala"
		_tmp15_ = li->color;
#line 135 "../src/game.vala"
		_tmp16_ = self->priv->tiles;
#line 135 "../src/game.vala"
		_tmp16__length1 = self->priv->tiles_length1;
#line 135 "../src/game.vala"
		_tmp16__length2 = self->priv->tiles_length2;
#line 135 "../src/game.vala"
		_tmp17_ = y;
#line 135 "../src/game.vala"
		_tmp18_ = x;
#line 135 "../src/game.vala"
		_tmp19_ = _tmp16_[((_tmp17_ + 1) * _tmp16__length2) + _tmp18_];
#line 135 "../src/game.vala"
		_tmp20_ = _tmp19_->color;
#line 135 "../src/game.vala"
		_tmp7_ = _tmp15_ == _tmp20_;
#line 876 "game.c"
	} else {
#line 135 "../src/game.vala"
		_tmp7_ = FALSE;
#line 880 "game.c"
	}
#line 135 "../src/game.vala"
	if (_tmp7_) {
#line 884 "game.c"
		Tile** _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		gint _tmp22_;
		gint _tmp23_;
		Tile* _tmp24_;
		GList* _tmp25_;
#line 136 "../src/game.vala"
		_tmp21_ = self->priv->tiles;
#line 136 "../src/game.vala"
		_tmp21__length1 = self->priv->tiles_length1;
#line 136 "../src/game.vala"
		_tmp21__length2 = self->priv->tiles_length2;
#line 136 "../src/game.vala"
		_tmp22_ = y;
#line 136 "../src/game.vala"
		_tmp23_ = x;
#line 136 "../src/game.vala"
		_tmp24_ = _tmp21_[((_tmp22_ + 1) * _tmp21__length2) + _tmp23_];
#line 136 "../src/game.vala"
		_tmp25_ = _game_connected_tiles (self, _tmp24_);
#line 136 "../src/game.vala"
		cl = g_list_concat (cl, _tmp25_);
#line 908 "game.c"
	}
#line 138 "../src/game.vala"
	_tmp28_ = y;
#line 138 "../src/game.vala"
	if ((_tmp28_ - 1) >= 0) {
#line 914 "game.c"
		Tile** _tmp29_;
		gint _tmp29__length1;
		gint _tmp29__length2;
		gint _tmp30_;
		gint _tmp31_;
		Tile* _tmp32_;
#line 138 "../src/game.vala"
		_tmp29_ = self->priv->tiles;
#line 138 "../src/game.vala"
		_tmp29__length1 = self->priv->tiles_length1;
#line 138 "../src/game.vala"
		_tmp29__length2 = self->priv->tiles_length2;
#line 138 "../src/game.vala"
		_tmp30_ = y;
#line 138 "../src/game.vala"
		_tmp31_ = x;
#line 138 "../src/game.vala"
		_tmp32_ = _tmp29_[((_tmp30_ - 1) * _tmp29__length2) + _tmp31_];
#line 138 "../src/game.vala"
		_tmp27_ = _tmp32_ != NULL;
#line 935 "game.c"
	} else {
#line 138 "../src/game.vala"
		_tmp27_ = FALSE;
#line 939 "game.c"
	}
#line 138 "../src/game.vala"
	if (_tmp27_) {
#line 943 "game.c"
		gint _tmp33_;
		Tile** _tmp34_;
		gint _tmp34__length1;
		gint _tmp34__length2;
		gint _tmp35_;
		gint _tmp36_;
		Tile* _tmp37_;
		gint _tmp38_;
#line 138 "../src/game.vala"
		_tmp33_ = li->color;
#line 138 "../src/game.vala"
		_tmp34_ = self->priv->tiles;
#line 138 "../src/game.vala"
		_tmp34__length1 = self->priv->tiles_length1;
#line 138 "../src/game.vala"
		_tmp34__length2 = self->priv->tiles_length2;
#line 138 "../src/game.vala"
		_tmp35_ = y;
#line 138 "../src/game.vala"
		_tmp36_ = x;
#line 138 "../src/game.vala"
		_tmp37_ = _tmp34_[((_tmp35_ - 1) * _tmp34__length2) + _tmp36_];
#line 138 "../src/game.vala"
		_tmp38_ = _tmp37_->color;
#line 138 "../src/game.vala"
		_tmp26_ = _tmp33_ == _tmp38_;
#line 970 "game.c"
	} else {
#line 138 "../src/game.vala"
		_tmp26_ = FALSE;
#line 974 "game.c"
	}
#line 138 "../src/game.vala"
	if (_tmp26_) {
#line 978 "game.c"
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		gint _tmp40_;
		gint _tmp41_;
		Tile* _tmp42_;
		GList* _tmp43_;
#line 139 "../src/game.vala"
		_tmp39_ = self->priv->tiles;
#line 139 "../src/game.vala"
		_tmp39__length1 = self->priv->tiles_length1;
#line 139 "../src/game.vala"
		_tmp39__length2 = self->priv->tiles_length2;
#line 139 "../src/game.vala"
		_tmp40_ = y;
#line 139 "../src/game.vala"
		_tmp41_ = x;
#line 139 "../src/game.vala"
		_tmp42_ = _tmp39_[((_tmp40_ - 1) * _tmp39__length2) + _tmp41_];
#line 139 "../src/game.vala"
		_tmp43_ = _game_connected_tiles (self, _tmp42_);
#line 139 "../src/game.vala"
		cl = g_list_concat (cl, _tmp43_);
#line 1002 "game.c"
	}
#line 141 "../src/game.vala"
	_tmp46_ = x;
#line 141 "../src/game.vala"
	_tmp47_ = self->priv->_columns;
#line 141 "../src/game.vala"
	if ((_tmp46_ + 1) < _tmp47_) {
#line 1010 "game.c"
		Tile** _tmp48_;
		gint _tmp48__length1;
		gint _tmp48__length2;
		gint _tmp49_;
		gint _tmp50_;
		Tile* _tmp51_;
#line 141 "../src/game.vala"
		_tmp48_ = self->priv->tiles;
#line 141 "../src/game.vala"
		_tmp48__length1 = self->priv->tiles_length1;
#line 141 "../src/game.vala"
		_tmp48__length2 = self->priv->tiles_length2;
#line 141 "../src/game.vala"
		_tmp49_ = y;
#line 141 "../src/game.vala"
		_tmp50_ = x;
#line 141 "../src/game.vala"
		_tmp51_ = _tmp48_[(_tmp49_ * _tmp48__length2) + (_tmp50_ + 1)];
#line 141 "../src/game.vala"
		_tmp45_ = _tmp51_ != NULL;
#line 1031 "game.c"
	} else {
#line 141 "../src/game.vala"
		_tmp45_ = FALSE;
#line 1035 "game.c"
	}
#line 141 "../src/game.vala"
	if (_tmp45_) {
#line 1039 "game.c"
		gint _tmp52_;
		Tile** _tmp53_;
		gint _tmp53__length1;
		gint _tmp53__length2;
		gint _tmp54_;
		gint _tmp55_;
		Tile* _tmp56_;
		gint _tmp57_;
#line 141 "../src/game.vala"
		_tmp52_ = li->color;
#line 141 "../src/game.vala"
		_tmp53_ = self->priv->tiles;
#line 141 "../src/game.vala"
		_tmp53__length1 = self->priv->tiles_length1;
#line 141 "../src/game.vala"
		_tmp53__length2 = self->priv->tiles_length2;
#line 141 "../src/game.vala"
		_tmp54_ = y;
#line 141 "../src/game.vala"
		_tmp55_ = x;
#line 141 "../src/game.vala"
		_tmp56_ = _tmp53_[(_tmp54_ * _tmp53__length2) + (_tmp55_ + 1)];
#line 141 "../src/game.vala"
		_tmp57_ = _tmp56_->color;
#line 141 "../src/game.vala"
		_tmp44_ = _tmp52_ == _tmp57_;
#line 1066 "game.c"
	} else {
#line 141 "../src/game.vala"
		_tmp44_ = FALSE;
#line 1070 "game.c"
	}
#line 141 "../src/game.vala"
	if (_tmp44_) {
#line 1074 "game.c"
		Tile** _tmp58_;
		gint _tmp58__length1;
		gint _tmp58__length2;
		gint _tmp59_;
		gint _tmp60_;
		Tile* _tmp61_;
		GList* _tmp62_;
#line 142 "../src/game.vala"
		_tmp58_ = self->priv->tiles;
#line 142 "../src/game.vala"
		_tmp58__length1 = self->priv->tiles_length1;
#line 142 "../src/game.vala"
		_tmp58__length2 = self->priv->tiles_length2;
#line 142 "../src/game.vala"
		_tmp59_ = y;
#line 142 "../src/game.vala"
		_tmp60_ = x;
#line 142 "../src/game.vala"
		_tmp61_ = _tmp58_[(_tmp59_ * _tmp58__length2) + (_tmp60_ + 1)];
#line 142 "../src/game.vala"
		_tmp62_ = _game_connected_tiles (self, _tmp61_);
#line 142 "../src/game.vala"
		cl = g_list_concat (cl, _tmp62_);
#line 1098 "game.c"
	}
#line 144 "../src/game.vala"
	_tmp65_ = x;
#line 144 "../src/game.vala"
	if ((_tmp65_ - 1) >= 0) {
#line 1104 "game.c"
		Tile** _tmp66_;
		gint _tmp66__length1;
		gint _tmp66__length2;
		gint _tmp67_;
		gint _tmp68_;
		Tile* _tmp69_;
#line 144 "../src/game.vala"
		_tmp66_ = self->priv->tiles;
#line 144 "../src/game.vala"
		_tmp66__length1 = self->priv->tiles_length1;
#line 144 "../src/game.vala"
		_tmp66__length2 = self->priv->tiles_length2;
#line 144 "../src/game.vala"
		_tmp67_ = y;
#line 144 "../src/game.vala"
		_tmp68_ = x;
#line 144 "../src/game.vala"
		_tmp69_ = _tmp66_[(_tmp67_ * _tmp66__length2) + (_tmp68_ - 1)];
#line 144 "../src/game.vala"
		_tmp64_ = _tmp69_ != NULL;
#line 1125 "game.c"
	} else {
#line 144 "../src/game.vala"
		_tmp64_ = FALSE;
#line 1129 "game.c"
	}
#line 144 "../src/game.vala"
	if (_tmp64_) {
#line 1133 "game.c"
		gint _tmp70_;
		Tile** _tmp71_;
		gint _tmp71__length1;
		gint _tmp71__length2;
		gint _tmp72_;
		gint _tmp73_;
		Tile* _tmp74_;
		gint _tmp75_;
#line 144 "../src/game.vala"
		_tmp70_ = li->color;
#line 144 "../src/game.vala"
		_tmp71_ = self->priv->tiles;
#line 144 "../src/game.vala"
		_tmp71__length1 = self->priv->tiles_length1;
#line 144 "../src/game.vala"
		_tmp71__length2 = self->priv->tiles_length2;
#line 144 "../src/game.vala"
		_tmp72_ = y;
#line 144 "../src/game.vala"
		_tmp73_ = x;
#line 144 "../src/game.vala"
		_tmp74_ = _tmp71_[(_tmp72_ * _tmp71__length2) + (_tmp73_ - 1)];
#line 144 "../src/game.vala"
		_tmp75_ = _tmp74_->color;
#line 144 "../src/game.vala"
		_tmp63_ = _tmp70_ == _tmp75_;
#line 1160 "game.c"
	} else {
#line 144 "../src/game.vala"
		_tmp63_ = FALSE;
#line 1164 "game.c"
	}
#line 144 "../src/game.vala"
	if (_tmp63_) {
#line 1168 "game.c"
		Tile** _tmp76_;
		gint _tmp76__length1;
		gint _tmp76__length2;
		gint _tmp77_;
		gint _tmp78_;
		Tile* _tmp79_;
		GList* _tmp80_;
#line 145 "../src/game.vala"
		_tmp76_ = self->priv->tiles;
#line 145 "../src/game.vala"
		_tmp76__length1 = self->priv->tiles_length1;
#line 145 "../src/game.vala"
		_tmp76__length2 = self->priv->tiles_length2;
#line 145 "../src/game.vala"
		_tmp77_ = y;
#line 145 "../src/game.vala"
		_tmp78_ = x;
#line 145 "../src/game.vala"
		_tmp79_ = _tmp76_[(_tmp77_ * _tmp76__length2) + (_tmp78_ - 1)];
#line 145 "../src/game.vala"
		_tmp80_ = _game_connected_tiles (self, _tmp79_);
#line 145 "../src/game.vala"
		cl = g_list_concat (cl, _tmp80_);
#line 1192 "game.c"
	}
#line 147 "../src/game.vala"
	result = cl;
#line 147 "../src/game.vala"
	return result;
#line 1198 "game.c"
}


GList*
game_connected_tiles (Game* self,
                      Tile* li)
{
	GList* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GList* cl = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
#line 150 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/game.vala"
	g_return_val_if_fail (li != NULL, NULL);
#line 152 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 152 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 152 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1223 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 152 "../src/game.vala"
		l_collection = _tmp0_;
#line 152 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 152 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1235 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 152 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 152 "../src/game.vala"
			l = _tmp1_;
#line 1242 "game.c"
			{
				Tile* _tmp2_;
#line 154 "../src/game.vala"
				_tmp2_ = l;
#line 154 "../src/game.vala"
				if (_tmp2_ != NULL) {
#line 1249 "game.c"
					Tile* _tmp3_;
#line 155 "../src/game.vala"
					_tmp3_ = l;
#line 155 "../src/game.vala"
					_tmp3_->visited = FALSE;
#line 1255 "game.c"
				}
#line 152 "../src/game.vala"
				_g_object_unref0 (l);
#line 1259 "game.c"
			}
		}
	}
#line 158 "../src/game.vala"
	_tmp4_ = _game_connected_tiles (self, li);
#line 158 "../src/game.vala"
	cl = _tmp4_;
#line 161 "../src/game.vala"
	_tmp5_ = cl;
#line 161 "../src/game.vala"
	if (g_list_length (_tmp5_) < ((guint) 2)) {
#line 162 "../src/game.vala"
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 162 "../src/game.vala"
		cl = NULL;
#line 1275 "game.c"
	}
#line 164 "../src/game.vala"
	result = cl;
#line 164 "../src/game.vala"
	return result;
#line 1281 "game.c"
}


Tile*
game_get_tile (Game* self,
               gint x,
               gint y)
{
	Tile* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
#line 167 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 169 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 169 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 169 "../src/game.vala"
	_tmp1_ = _tmp0_[(y * _tmp0__length2) + x];
#line 169 "../src/game.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 169 "../src/game.vala"
	result = _tmp2_;
#line 169 "../src/game.vala"
	return result;
#line 1312 "game.c"
}


gboolean
game_remove_connected_tiles (Game* self,
                             Tile* tile)
{
	gboolean result = FALSE;
	GList* cl = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gint new_x = 0;
	GList* _tmp69_;
	gboolean _tmp70_;
#line 172 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "../src/game.vala"
	g_return_val_if_fail (tile != NULL, FALSE);
#line 174 "../src/game.vala"
	_tmp0_ = game_connected_tiles (self, tile);
#line 174 "../src/game.vala"
	cl = _tmp0_;
#line 176 "../src/game.vala"
	_tmp1_ = cl;
#line 176 "../src/game.vala"
	if (_tmp1_ == NULL) {
#line 177 "../src/game.vala"
		result = FALSE;
#line 177 "../src/game.vala"
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 177 "../src/game.vala"
		return result;
#line 1346 "game.c"
	}
#line 179 "../src/game.vala"
	_tmp2_ = cl;
#line 1350 "game.c"
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
#line 179 "../src/game.vala"
		l_collection = _tmp2_;
#line 179 "../src/game.vala"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
#line 1358 "game.c"
			Tile* _tmp3_;
			Tile* l = NULL;
#line 179 "../src/game.vala"
			_tmp3_ = _g_object_ref0 ((Tile*) l_it->data);
#line 179 "../src/game.vala"
			l = _tmp3_;
#line 1365 "game.c"
			{
				Tile* _tmp4_;
#line 180 "../src/game.vala"
				_tmp4_ = l;
#line 180 "../src/game.vala"
				tile_set_closed (_tmp4_, TRUE);
#line 179 "../src/game.vala"
				_g_object_unref0 (l);
#line 1374 "game.c"
			}
		}
	}
#line 182 "../src/game.vala"
	new_x = 0;
#line 1380 "game.c"
	{
		gint x = 0;
#line 184 "../src/game.vala"
		x = 0;
#line 1385 "game.c"
		{
			gboolean _tmp5_ = FALSE;
#line 184 "../src/game.vala"
			_tmp5_ = TRUE;
#line 184 "../src/game.vala"
			while (TRUE) {
#line 1392 "game.c"
				gint _tmp7_;
				gint _tmp8_;
				GList* not_closed_tiles = NULL;
				GList* closed_tiles = NULL;
				GList* _tmp26_;
				gboolean has_empty_col = FALSE;
				gboolean _tmp55_;
#line 184 "../src/game.vala"
				if (!_tmp5_) {
#line 1402 "game.c"
					gint _tmp6_;
#line 184 "../src/game.vala"
					_tmp6_ = x;
#line 184 "../src/game.vala"
					x = _tmp6_ + 1;
#line 1408 "game.c"
				}
#line 184 "../src/game.vala"
				_tmp5_ = FALSE;
#line 184 "../src/game.vala"
				_tmp7_ = x;
#line 184 "../src/game.vala"
				_tmp8_ = self->priv->_columns;
#line 184 "../src/game.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 184 "../src/game.vala"
					break;
#line 1420 "game.c"
				}
#line 186 "../src/game.vala"
				not_closed_tiles = NULL;
#line 187 "../src/game.vala"
				closed_tiles = NULL;
#line 1426 "game.c"
				{
					gint y = 0;
#line 190 "../src/game.vala"
					y = 0;
#line 1431 "game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 190 "../src/game.vala"
						_tmp9_ = TRUE;
#line 190 "../src/game.vala"
						while (TRUE) {
#line 1438 "game.c"
							gint _tmp11_;
							gint _tmp12_;
							Tile* li = NULL;
							Tile** _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							gint _tmp14_;
							gint _tmp15_;
							Tile* _tmp16_;
							Tile* _tmp17_;
							Tile* _tmp18_;
							Tile* _tmp19_;
							gboolean _tmp20_;
							gboolean _tmp21_;
#line 190 "../src/game.vala"
							if (!_tmp9_) {
#line 1455 "game.c"
								gint _tmp10_;
#line 190 "../src/game.vala"
								_tmp10_ = y;
#line 190 "../src/game.vala"
								y = _tmp10_ + 1;
#line 1461 "game.c"
							}
#line 190 "../src/game.vala"
							_tmp9_ = FALSE;
#line 190 "../src/game.vala"
							_tmp11_ = y;
#line 190 "../src/game.vala"
							_tmp12_ = self->priv->_rows;
#line 190 "../src/game.vala"
							if (!(_tmp11_ < _tmp12_)) {
#line 190 "../src/game.vala"
								break;
#line 1473 "game.c"
							}
#line 192 "../src/game.vala"
							_tmp13_ = self->priv->tiles;
#line 192 "../src/game.vala"
							_tmp13__length1 = self->priv->tiles_length1;
#line 192 "../src/game.vala"
							_tmp13__length2 = self->priv->tiles_length2;
#line 192 "../src/game.vala"
							_tmp14_ = y;
#line 192 "../src/game.vala"
							_tmp15_ = x;
#line 192 "../src/game.vala"
							_tmp16_ = _tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_];
#line 192 "../src/game.vala"
							_tmp17_ = _g_object_ref0 (_tmp16_);
#line 192 "../src/game.vala"
							li = _tmp17_;
#line 194 "../src/game.vala"
							_tmp18_ = li;
#line 194 "../src/game.vala"
							if (_tmp18_ == NULL) {
#line 195 "../src/game.vala"
								_g_object_unref0 (li);
#line 195 "../src/game.vala"
								break;
#line 1499 "game.c"
							}
#line 197 "../src/game.vala"
							_tmp19_ = li;
#line 197 "../src/game.vala"
							_tmp20_ = tile_get_closed (_tmp19_);
#line 197 "../src/game.vala"
							_tmp21_ = _tmp20_;
#line 197 "../src/game.vala"
							if (_tmp21_) {
#line 1509 "game.c"
								Tile* _tmp22_;
								Tile* _tmp23_;
#line 198 "../src/game.vala"
								_tmp22_ = li;
#line 198 "../src/game.vala"
								_tmp23_ = _g_object_ref0 (_tmp22_);
#line 198 "../src/game.vala"
								closed_tiles = g_list_append (closed_tiles, _tmp23_);
#line 1518 "game.c"
							} else {
								Tile* _tmp24_;
								Tile* _tmp25_;
#line 200 "../src/game.vala"
								_tmp24_ = li;
#line 200 "../src/game.vala"
								_tmp25_ = _g_object_ref0 (_tmp24_);
#line 200 "../src/game.vala"
								not_closed_tiles = g_list_append (not_closed_tiles, _tmp25_);
#line 1528 "game.c"
							}
#line 190 "../src/game.vala"
							_g_object_unref0 (li);
#line 1532 "game.c"
						}
					}
				}
#line 204 "../src/game.vala"
				_tmp26_ = closed_tiles;
#line 204 "../src/game.vala"
				closed_tiles = NULL;
#line 204 "../src/game.vala"
				not_closed_tiles = g_list_concat (not_closed_tiles, _tmp26_);
#line 1542 "game.c"
				{
					gint y = 0;
#line 207 "../src/game.vala"
					y = 0;
#line 1547 "game.c"
					{
						gboolean _tmp27_ = FALSE;
#line 207 "../src/game.vala"
						_tmp27_ = TRUE;
#line 207 "../src/game.vala"
						while (TRUE) {
#line 1554 "game.c"
							gint _tmp29_;
							gint _tmp30_;
							Tile** _tmp31_;
							gint _tmp31__length1;
							gint _tmp31__length2;
							gint _tmp32_;
							gint _tmp33_;
							GList* _tmp34_;
							gint _tmp35_;
							gconstpointer _tmp36_;
							Tile* _tmp37_;
							Tile* _tmp38_;
#line 207 "../src/game.vala"
							if (!_tmp27_) {
#line 1569 "game.c"
								gint _tmp28_;
#line 207 "../src/game.vala"
								_tmp28_ = y;
#line 207 "../src/game.vala"
								y = _tmp28_ + 1;
#line 1575 "game.c"
							}
#line 207 "../src/game.vala"
							_tmp27_ = FALSE;
#line 207 "../src/game.vala"
							_tmp29_ = y;
#line 207 "../src/game.vala"
							_tmp30_ = self->priv->_rows;
#line 207 "../src/game.vala"
							if (!(_tmp29_ < _tmp30_)) {
#line 207 "../src/game.vala"
								break;
#line 1587 "game.c"
							}
#line 208 "../src/game.vala"
							_tmp31_ = self->priv->tiles;
#line 208 "../src/game.vala"
							_tmp31__length1 = self->priv->tiles_length1;
#line 208 "../src/game.vala"
							_tmp31__length2 = self->priv->tiles_length2;
#line 208 "../src/game.vala"
							_tmp32_ = y;
#line 208 "../src/game.vala"
							_tmp33_ = new_x;
#line 208 "../src/game.vala"
							_tmp34_ = not_closed_tiles;
#line 208 "../src/game.vala"
							_tmp35_ = y;
#line 208 "../src/game.vala"
							_tmp36_ = g_list_nth_data (_tmp34_, (guint) _tmp35_);
#line 208 "../src/game.vala"
							_tmp37_ = _g_object_ref0 ((Tile*) _tmp36_);
#line 208 "../src/game.vala"
							_g_object_unref0 (_tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_]);
#line 208 "../src/game.vala"
							_tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_] = _tmp37_;
#line 208 "../src/game.vala"
							_tmp38_ = _tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_];
#line 1613 "game.c"
						}
					}
				}
#line 211 "../src/game.vala"
				has_empty_col = TRUE;
#line 1619 "game.c"
				{
					gint y = 0;
#line 214 "../src/game.vala"
					y = 0;
#line 1624 "game.c"
					{
						gboolean _tmp39_ = FALSE;
#line 214 "../src/game.vala"
						_tmp39_ = TRUE;
#line 214 "../src/game.vala"
						while (TRUE) {
#line 1631 "game.c"
							gint _tmp41_;
							gint _tmp42_;
							Tile* l = NULL;
							Tile** _tmp43_;
							gint _tmp43__length1;
							gint _tmp43__length2;
							gint _tmp44_;
							gint _tmp45_;
							Tile* _tmp46_;
							Tile* _tmp47_;
							Tile* _tmp48_;
							Tile* _tmp49_;
							gint _tmp50_;
							gint _tmp51_;
							Tile* _tmp52_;
							gboolean _tmp53_;
							gboolean _tmp54_;
#line 214 "../src/game.vala"
							if (!_tmp39_) {
#line 1651 "game.c"
								gint _tmp40_;
#line 214 "../src/game.vala"
								_tmp40_ = y;
#line 214 "../src/game.vala"
								y = _tmp40_ + 1;
#line 1657 "game.c"
							}
#line 214 "../src/game.vala"
							_tmp39_ = FALSE;
#line 214 "../src/game.vala"
							_tmp41_ = y;
#line 214 "../src/game.vala"
							_tmp42_ = self->priv->_rows;
#line 214 "../src/game.vala"
							if (!(_tmp41_ < _tmp42_)) {
#line 214 "../src/game.vala"
								break;
#line 1669 "game.c"
							}
#line 216 "../src/game.vala"
							_tmp43_ = self->priv->tiles;
#line 216 "../src/game.vala"
							_tmp43__length1 = self->priv->tiles_length1;
#line 216 "../src/game.vala"
							_tmp43__length2 = self->priv->tiles_length2;
#line 216 "../src/game.vala"
							_tmp44_ = y;
#line 216 "../src/game.vala"
							_tmp45_ = new_x;
#line 216 "../src/game.vala"
							_tmp46_ = _tmp43_[(_tmp44_ * _tmp43__length2) + _tmp45_];
#line 216 "../src/game.vala"
							_tmp47_ = _g_object_ref0 (_tmp46_);
#line 216 "../src/game.vala"
							l = _tmp47_;
#line 218 "../src/game.vala"
							_tmp48_ = l;
#line 218 "../src/game.vala"
							if (_tmp48_ == NULL) {
#line 219 "../src/game.vala"
								_g_object_unref0 (l);
#line 219 "../src/game.vala"
								break;
#line 1695 "game.c"
							}
#line 221 "../src/game.vala"
							_tmp49_ = l;
#line 221 "../src/game.vala"
							_tmp50_ = new_x;
#line 221 "../src/game.vala"
							_tmp51_ = y;
#line 221 "../src/game.vala"
							tile_update_position (_tmp49_, _tmp50_, _tmp51_);
#line 223 "../src/game.vala"
							_tmp52_ = l;
#line 223 "../src/game.vala"
							_tmp53_ = tile_get_closed (_tmp52_);
#line 223 "../src/game.vala"
							_tmp54_ = _tmp53_;
#line 223 "../src/game.vala"
							if (!_tmp54_) {
#line 224 "../src/game.vala"
								has_empty_col = FALSE;
#line 1715 "game.c"
							}
#line 214 "../src/game.vala"
							_g_object_unref0 (l);
#line 1719 "game.c"
						}
					}
				}
#line 228 "../src/game.vala"
				_tmp55_ = has_empty_col;
#line 228 "../src/game.vala"
				if (!_tmp55_) {
#line 1727 "game.c"
					gint _tmp56_;
#line 229 "../src/game.vala"
					_tmp56_ = new_x;
#line 229 "../src/game.vala"
					new_x = _tmp56_ + 1;
#line 1733 "game.c"
				}
#line 184 "../src/game.vala"
				(closed_tiles == NULL) ? NULL : (closed_tiles = (_g_list_free__g_object_unref0_ (closed_tiles), NULL));
#line 184 "../src/game.vala"
				(not_closed_tiles == NULL) ? NULL : (not_closed_tiles = (_g_list_free__g_object_unref0_ (not_closed_tiles), NULL));
#line 1739 "game.c"
			}
		}
	}
	{
		gboolean _tmp57_ = FALSE;
#line 233 "../src/game.vala"
		_tmp57_ = TRUE;
#line 233 "../src/game.vala"
		while (TRUE) {
#line 1749 "game.c"
			gint _tmp59_;
			gint _tmp60_;
#line 233 "../src/game.vala"
			if (!_tmp57_) {
#line 1754 "game.c"
				gint _tmp58_;
#line 233 "../src/game.vala"
				_tmp58_ = new_x;
#line 233 "../src/game.vala"
				new_x = _tmp58_ + 1;
#line 1760 "game.c"
			}
#line 233 "../src/game.vala"
			_tmp57_ = FALSE;
#line 233 "../src/game.vala"
			_tmp59_ = new_x;
#line 233 "../src/game.vala"
			_tmp60_ = self->priv->_columns;
#line 233 "../src/game.vala"
			if (!(_tmp59_ < _tmp60_)) {
#line 233 "../src/game.vala"
				break;
#line 1772 "game.c"
			}
			{
				gint y = 0;
#line 234 "../src/game.vala"
				y = 0;
#line 1778 "game.c"
				{
					gboolean _tmp61_ = FALSE;
#line 234 "../src/game.vala"
					_tmp61_ = TRUE;
#line 234 "../src/game.vala"
					while (TRUE) {
#line 1785 "game.c"
						gint _tmp63_;
						gint _tmp64_;
						Tile** _tmp65_;
						gint _tmp65__length1;
						gint _tmp65__length2;
						gint _tmp66_;
						gint _tmp67_;
						Tile* _tmp68_;
#line 234 "../src/game.vala"
						if (!_tmp61_) {
#line 1796 "game.c"
							gint _tmp62_;
#line 234 "../src/game.vala"
							_tmp62_ = y;
#line 234 "../src/game.vala"
							y = _tmp62_ + 1;
#line 1802 "game.c"
						}
#line 234 "../src/game.vala"
						_tmp61_ = FALSE;
#line 234 "../src/game.vala"
						_tmp63_ = y;
#line 234 "../src/game.vala"
						_tmp64_ = self->priv->_rows;
#line 234 "../src/game.vala"
						if (!(_tmp63_ < _tmp64_)) {
#line 234 "../src/game.vala"
							break;
#line 1814 "game.c"
						}
#line 235 "../src/game.vala"
						_tmp65_ = self->priv->tiles;
#line 235 "../src/game.vala"
						_tmp65__length1 = self->priv->tiles_length1;
#line 235 "../src/game.vala"
						_tmp65__length2 = self->priv->tiles_length2;
#line 235 "../src/game.vala"
						_tmp66_ = y;
#line 235 "../src/game.vala"
						_tmp67_ = new_x;
#line 235 "../src/game.vala"
						_g_object_unref0 (_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_]);
#line 235 "../src/game.vala"
						_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_] = NULL;
#line 235 "../src/game.vala"
						_tmp68_ = _tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_];
#line 1832 "game.c"
					}
				}
			}
		}
	}
#line 237 "../src/game.vala"
	_tmp69_ = cl;
#line 237 "../src/game.vala"
	game_increment_score_from_tiles (self, (gint) g_list_length (_tmp69_));
#line 239 "../src/game.vala"
	_tmp70_ = self->priv->is_started;
#line 239 "../src/game.vala"
	if (!_tmp70_) {
#line 240 "../src/game.vala"
		self->priv->is_started = TRUE;
#line 241 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
#line 1850 "game.c"
	}
#line 244 "../src/game.vala"
	if (game_has_completed (self)) {
#line 246 "../src/game.vala"
		if (game_has_won (self)) {
#line 247 "../src/game.vala"
			game_increment_score (self, 1000);
#line 1858 "game.c"
		}
#line 248 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 1862 "game.c"
	}
#line 251 "../src/game.vala"
	result = FALSE;
#line 251 "../src/game.vala"
	(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 251 "../src/game.vala"
	return result;
#line 1870 "game.c"
}


void
game_reset_visit (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 254 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 256 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 256 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1888 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 256 "../src/game.vala"
		l_collection = _tmp0_;
#line 256 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 256 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1900 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 256 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 256 "../src/game.vala"
			l = _tmp1_;
#line 1907 "game.c"
			{
				Tile* _tmp2_;
#line 258 "../src/game.vala"
				_tmp2_ = l;
#line 258 "../src/game.vala"
				if (_tmp2_ != NULL) {
#line 1914 "game.c"
					Tile* _tmp3_;
#line 259 "../src/game.vala"
					_tmp3_ = l;
#line 259 "../src/game.vala"
					_tmp3_->visited = FALSE;
#line 1920 "game.c"
				}
#line 256 "../src/game.vala"
				_g_object_unref0 (l);
#line 1924 "game.c"
			}
		}
	}
}


gboolean
game_has_completed (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 263 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 265 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 265 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1946 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 265 "../src/game.vala"
		l_collection = _tmp0_;
#line 265 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 265 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1958 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 265 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 265 "../src/game.vala"
			l = _tmp1_;
#line 1965 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				Tile* _tmp4_;
#line 267 "../src/game.vala"
				_tmp4_ = l;
#line 267 "../src/game.vala"
				if (_tmp4_ != NULL) {
#line 1974 "game.c"
					Tile* _tmp5_;
					gboolean _tmp6_;
					gboolean _tmp7_;
#line 267 "../src/game.vala"
					_tmp5_ = l;
#line 267 "../src/game.vala"
					_tmp6_ = tile_get_closed (_tmp5_);
#line 267 "../src/game.vala"
					_tmp7_ = _tmp6_;
#line 267 "../src/game.vala"
					_tmp3_ = !_tmp7_;
#line 1986 "game.c"
				} else {
#line 267 "../src/game.vala"
					_tmp3_ = FALSE;
#line 1990 "game.c"
				}
#line 267 "../src/game.vala"
				if (_tmp3_) {
#line 1994 "game.c"
					Tile* _tmp8_;
					GList* _tmp9_;
					GList* _tmp10_;
#line 267 "../src/game.vala"
					_tmp8_ = l;
#line 267 "../src/game.vala"
					_tmp9_ = game_connected_tiles (self, _tmp8_);
#line 267 "../src/game.vala"
					_tmp10_ = _tmp9_;
#line 267 "../src/game.vala"
					_tmp2_ = g_list_length (_tmp10_) > ((guint) 1);
#line 267 "../src/game.vala"
					(_tmp10_ == NULL) ? NULL : (_tmp10_ = (_g_list_free__g_object_unref0_ (_tmp10_), NULL));
#line 2008 "game.c"
				} else {
#line 267 "../src/game.vala"
					_tmp2_ = FALSE;
#line 2012 "game.c"
				}
#line 267 "../src/game.vala"
				if (_tmp2_) {
#line 268 "../src/game.vala"
					result = FALSE;
#line 268 "../src/game.vala"
					_g_object_unref0 (l);
#line 268 "../src/game.vala"
					return result;
#line 2022 "game.c"
				}
#line 265 "../src/game.vala"
				_g_object_unref0 (l);
#line 2026 "game.c"
			}
		}
	}
#line 271 "../src/game.vala"
	result = TRUE;
#line 271 "../src/game.vala"
	return result;
#line 2034 "game.c"
}


gboolean
game_has_won (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 274 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 276 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 276 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 2053 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 276 "../src/game.vala"
		l_collection = _tmp0_;
#line 276 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 276 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 2065 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 276 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 276 "../src/game.vala"
			l = _tmp1_;
#line 2072 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				Tile* _tmp3_;
#line 278 "../src/game.vala"
				_tmp3_ = l;
#line 278 "../src/game.vala"
				if (_tmp3_ != NULL) {
#line 2080 "game.c"
					Tile* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
#line 278 "../src/game.vala"
					_tmp4_ = l;
#line 278 "../src/game.vala"
					_tmp5_ = tile_get_closed (_tmp4_);
#line 278 "../src/game.vala"
					_tmp6_ = _tmp5_;
#line 278 "../src/game.vala"
					_tmp2_ = !_tmp6_;
#line 2092 "game.c"
				} else {
#line 278 "../src/game.vala"
					_tmp2_ = FALSE;
#line 2096 "game.c"
				}
#line 278 "../src/game.vala"
				if (_tmp2_) {
#line 279 "../src/game.vala"
					result = FALSE;
#line 279 "../src/game.vala"
					_g_object_unref0 (l);
#line 279 "../src/game.vala"
					return result;
#line 2106 "game.c"
				}
#line 276 "../src/game.vala"
				_g_object_unref0 (l);
#line 2110 "game.c"
			}
		}
	}
#line 282 "../src/game.vala"
	result = TRUE;
#line 282 "../src/game.vala"
	return result;
#line 2118 "game.c"
}


void
game_increment_score_from_tiles (Game* self,
                                 gint n_tiles)
{
	gint points_awarded = 0;
	gint _tmp0_;
#line 285 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/game.vala"
	points_awarded = 0;
#line 289 "../src/game.vala"
	if (n_tiles >= 3) {
#line 290 "../src/game.vala"
		points_awarded = (n_tiles - 2) * (n_tiles - 2);
#line 2136 "game.c"
	}
#line 292 "../src/game.vala"
	_tmp0_ = points_awarded;
#line 292 "../src/game.vala"
	game_increment_score (self, _tmp0_);
#line 2142 "game.c"
}


void
game_increment_score (Game* self,
                      gint increment)
{
	gint _tmp0_;
#line 295 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/game.vala"
	_tmp0_ = self->priv->_score;
#line 297 "../src/game.vala"
	game_set_score (self, _tmp0_ + increment);
#line 298 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_UPDATE_SCORE_SIGNAL], 0, increment);
#line 2159 "game.c"
}


gint
game_get_score (Game* self)
{
	gint result;
	gint _tmp0_;
#line 75 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../src/game.vala"
	_tmp0_ = self->priv->_score;
#line 75 "../src/game.vala"
	result = _tmp0_;
#line 75 "../src/game.vala"
	return result;
#line 2176 "game.c"
}


void
game_set_score (Game* self,
                gint value)
{
#line 75 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/game.vala"
	if (game_get_score (self) != value) {
#line 75 "../src/game.vala"
		self->priv->_score = value;
#line 75 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
#line 2192 "game.c"
	}
}


gint
game_get_color_num (Game* self)
{
	gint result;
	gint _tmp0_;
#line 80 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../src/game.vala"
	_tmp0_ = self->priv->_color_num;
#line 80 "../src/game.vala"
	result = _tmp0_;
#line 80 "../src/game.vala"
	return result;
#line 2210 "game.c"
}


void
game_set_color_num (Game* self,
                    gint value)
{
	gboolean _tmp0_ = FALSE;
#line 81 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/game.vala"
	if (value < 2) {
#line 83 "../src/game.vala"
		_tmp0_ = TRUE;
#line 2225 "game.c"
	} else {
#line 83 "../src/game.vala"
		_tmp0_ = value > 4;
#line 2229 "game.c"
	}
#line 83 "../src/game.vala"
	if (_tmp0_) {
#line 84 "../src/game.vala"
		self->priv->_color_num = 3;
#line 2235 "game.c"
	} else {
#line 86 "../src/game.vala"
		self->priv->_color_num = value;
#line 2239 "game.c"
	}
#line 81 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLOR_NUM_PROPERTY]);
#line 2243 "game.c"
}


gint
game_get_rows (Game* self)
{
	gint result;
	gint _tmp0_;
#line 91 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "../src/game.vala"
	_tmp0_ = self->priv->_rows;
#line 91 "../src/game.vala"
	result = _tmp0_;
#line 91 "../src/game.vala"
	return result;
#line 2260 "game.c"
}


void
game_set_rows (Game* self,
               gint value)
{
#line 91 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/game.vala"
	if (game_get_rows (self) != value) {
#line 91 "../src/game.vala"
		self->priv->_rows = value;
#line 91 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_ROWS_PROPERTY]);
#line 2276 "game.c"
	}
}


gint
game_get_columns (Game* self)
{
	gint result;
	gint _tmp0_;
#line 92 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "../src/game.vala"
	_tmp0_ = self->priv->_columns;
#line 92 "../src/game.vala"
	result = _tmp0_;
#line 92 "../src/game.vala"
	return result;
#line 2294 "game.c"
}


void
game_set_columns (Game* self,
                  gint value)
{
#line 92 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/game.vala"
	if (game_get_columns (self) != value) {
#line 92 "../src/game.vala"
		self->priv->_columns = value;
#line 92 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLUMNS_PROPERTY]);
#line 2310 "game.c"
	}
}


static void
game_class_init (GameClass * klass)
{
#line 69 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 69 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLOR_NUM_PROPERTY, game_properties[GAME_COLOR_NUM_PROPERTY] = g_param_spec_int ("color-num", "color-num", "color-num", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ROWS_PROPERTY, game_properties[GAME_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLUMNS_PROPERTY, game_properties[GAME_COLUMNS_PROPERTY] = g_param_spec_int ("columns", "columns", "columns", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	game_signals[GAME_UPDATE_SCORE_SIGNAL] = g_signal_new ("update-score", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 69 "../src/game.vala"
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 69 "../src/game.vala"
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2342 "game.c"
}


static void
game_instance_init (Game * self)
{
#line 69 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 72 "../src/game.vala"
	self->priv->is_started = FALSE;
#line 75 "../src/game.vala"
	self->priv->_score = 0;
#line 77 "../src/game.vala"
	self->priv->_color_num = 3;
#line 91 "../src/game.vala"
	self->priv->_rows = 8;
#line 92 "../src/game.vala"
	self->priv->_columns = 8;
#line 2361 "game.c"
}


static void
game_finalize (GObject * obj)
{
	Game * self;
#line 69 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 71 "../src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2375 "game.c"
}


/**
 *  This is the model layer of the whole game. All game logic goes here. This class tries not to
 *  bring in any visual stuff to comply the separation of view-model idea.
 */
GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}


static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "../src/game.vala"
	switch (property_id) {
#line 69 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_score (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLOR_NUM_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_color_num (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_ROWS_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_rows (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLUMNS_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_columns (self));
#line 69 "../src/game.vala"
		break;
#line 2432 "game.c"
		default:
#line 69 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/game.vala"
		break;
#line 2438 "game.c"
	}
}


static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "../src/game.vala"
	switch (property_id) {
#line 69 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 69 "../src/game.vala"
		game_set_score (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLOR_NUM_PROPERTY:
#line 69 "../src/game.vala"
		game_set_color_num (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_ROWS_PROPERTY:
#line 69 "../src/game.vala"
		game_set_rows (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLUMNS_PROPERTY:
#line 69 "../src/game.vala"
		game_set_columns (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 2477 "game.c"
		default:
#line 69 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/game.vala"
		break;
#line 2483 "game.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



